<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <!-- Initialize Bootstrap 4 -->
    <link rel="stylesheet" href="https://cdn.staticfile.org/twitter-bootstrap/4.3.1/css/bootstrap.min.css">
    <script src="https://cdn.staticfile.org/jquery/3.2.1/jquery.min.js"></script>
    <script src="https://cdn.staticfile.org/popper.js/1.15.0/umd/popper.min.js"></script>
    <script src="https://cdn.staticfile.org/twitter-bootstrap/4.3.1/js/bootstrap.min.js"></script>
    <script src="getTokenFromCookie.js"></script>
    <link rel="stylesheet" type="text/css" href="css/global.css">
    <script src="getTokenFromCookie.js"></script>
    <script src="parseJwt.js"></script>
    <title>Collaboration PDF file</title>
</head>

<body>
	<ul class="nav justify-content-end">
		<li class="nav-item">
			<button type="button" id="bouton-logout" class="btn btn-light" style="border: 0.5px solid lightgray;">Log out</button>
			<button type="button" id="bouton-fichiers" class="btn btn-light" style="border: 0.5px solid lightgray;">Accueil</button>
		</li>
	</ul>
	
    <h1>Cours</h1>
    <nav class="breadcrumb" id = "coursename">
    </nav>

    <div class="row">
        <div class="col" style="height: 500px"> 
            <iframe id="pdfframe" frameborder="0"
                style="overflow:hidden; overflow-x:hidden; overflow-y:hidden; height: 100%; width: 100%"></iframe>
        </div>
        <div class="col" style="height: 500px">
            <iframe id="txtframe" frameborder="0"
                style="overflow:hidden; overflow-x:hidden; overflow-y:hidden; height: 100%; width: 100%"></iframe>
        </div>
        <div class="col">
            <div class="row">
                <label>
                    Private <input type="checkbox" checked=false name="private" id ="privatebox">
                </label>
                <button id="addComment">Add/Update</button>
            </div>
            <div class="row">
                <input type="text" name="commentText"></input>
            </div>
            <div class="row">
                <div id="commentHolder">
                    <!--ajout des commentaires-->
                    <button id="showHidden">Show hidden comments</button>
                </div>
            </div>
        </div>
    </div>

    <script>
        const params = new URLSearchParams(document.location.search);
        const filename = params.get("filename");
        const courseid = params.get("courseid");
        const fileid = courseid + "-" + filename;
        var commentHolder = document.getElementById("commentHolder");
        var showHiddenButton = document.getElementById("showHidden");
        var commentText = document.getElementsByName("commentText")[0];
        var pageNumber = 1;
        editionMode = false;
        editedCom = null;
        hidden = true;

        let token = parseJwt(getTokenFromCookie());
        console.log(token);

        function editComment(clickedComment) {
            console.log(clickedComment)
            editedCom = clickedComment
            commentText.value = editedCom.firstChild.textContent
            editionMode = true
        }

    function deleteComment(clickedComment){
        $.ajax({
            type: "DELETE",
            headers:{"Authorization":"Bearer " + getTokenFromCookie()},
            url: "/api/comment?_id="+clickedComment.getElementsByClassName("id")[0].textContent,
            success: (data) => {
                console.log(data)               
            },
            error: (err) => {
                console.log(JSON.stringify(err))
            }
        })
        clickedComment.remove();
    }



    function hideComment(clickedComment){
        console.log(clickedComment)
        if(clickedComment.classList.contains("hidden")){
            keepComment(clickedComment);
        } else {
            $.ajax({
                type: "PUT",
                headers:{"Authorization":"Bearer " +getTokenFromCookie()
                },
                url: "/api/comment/hide?fileid="+fileid+"&commentid="+clickedComment.getElementsByClassName("id")[0].textContent,
                success: (data) => {
                    console.log(data);   
                    if(hidden){clickedComment.style.display = "none";}
                    clickedComment.getElementsByClassName("hide")[0].textContent = "keep";
                    clickedComment.classList.add("hidden"); 
                },
                error: (err) => {
                    console.log(JSON.stringify(err));
                }
            })
        }
    }

    function keepComment(clickedComment){
        console.log(clickedComment)
        $.ajax({
            type: "DELETE",
            headers:{"Authorization":"Bearer " +getTokenFromCookie()
            },
            url: "/api/comment/hide?fileid="+fileid+"&commentid="+clickedComment.getElementsByClassName("id")[0].textContent,
            success: (data) => {
                console.log(data);
                clickedComment.getElementsByClassName("hide")[0].textContent = "hide";
                clickedComment.classList.remove("hidden"); 
            },
            error: (err) => {
                console.log(JSON.stringify(err));
            }
        })
    }




    $(document).ready(function () {
            $("#pdfframe").attr("src", "/static/" + courseid + "/" + filename);
            $("#txtframe").attr("src", "/static/" + courseid + "/" + filename.replace(".pdf", ".txt"));
            $('#bouton-logout').on('click', function () {
				document.cookie = "token=;expires=Thu, 01 Jan 1970 00:00:01 GMT";
				window.location.href= "login.html";
			});
            $('#bouton-fichiers').on('click', function () {
				window.location.href= "fichiers.html";
            });
            var fileInfo = $("#coursename");
            var info = "<span class='breadcrumb-item active'>" + courseid + "</span><span class='breadcrumb-item active'>Un cours en PDF</span>"
            fileInfo.append(info);
            $.ajax({
                type: "GET",
                headers: { "Authorization": "Bearer " + getTokenFromCookie() },
                url: "/api/comment?fileid=" + fileid,
                success: (data) => {
                    console.log(data)
                    jsonData = JSON.parse(data)
                    jsonData.result.forEach(comment => {
                        var nextComment = document.createElement("p");
                        var textNode = document.createTextNode(comment.content);
                        var hideLabel = document.createElement("button");
                        hideLabel.textContent = "hide";
                        hideLabel.className = "hide";
                        hideLabel.addEventListener("click", hideComment.bind(null,nextComment));
                        var idLabel = document.createElement("label");
                        idLabel.textContent = comment._id;
                        idLabel.className = "id";
                        idLabel.style.display = "none";
                        var userLabel = document.createElement("label");
                        userLabel.textContent = " - Author : "+comment.username;
                        userLabel.className = "user";
                        nextComment.appendChild(textNode);
                        nextComment.appendChild(userLabel)
                        nextComment.appendChild(hideLabel);
                   
                        nextComment.appendChild(idLabel)
                        //show edit and delete if user=writer
                        if((comment.username = token.username) || (token.username = "admin")){
                            var editLabel = document.createElement("button");
                            editLabel.textContent = "edit";
                            editLabel.className = "edit";
                            editLabel.addEventListener("click", editComment.bind(null,nextComment));
                            var deleteLabel = document.createElement("button");
                            deleteLabel.textContent = "delete";
                            deleteLabel.className = "delete";
                            deleteLabel.addEventListener("click", deleteComment.bind(null,nextComment));
                            nextComment.appendChild(editLabel);
                            nextComment.appendChild(deleteLabel);
                        }
                        //visible en fonction du n° de page
                        if(comment.page!=pageNumber){
                            nextComment.style.display = "none";
                        }
                        if(comment.hidden){
                            hideLabel.textContent = "keep";
                            nextComment.style.display = "none";
                            nextComment.classList.add("hidden"); 
                        } 
                        commentHolder.insertBefore(nextComment,commentHolder.firstChild);

                    });
                },
                error: (err) => {
                    console.log(JSON.stringify(err))
                }
            })

            //useless
        $.ajax({
            type: "GET",
            headers:{"Authorization":"Bearer " + getTokenFromCookie() },
            url: "/api/course/file?filename="+filename+"&courseid="+courseid,
            success: (data) => {
                console.log(data)               
            },
            error: (err) => {
                console.log(JSON.stringify(err))
            }
        })

        showHiddenButton.onclick = function(){
            var hiddenComments = document.getElementsByClassName("hidden")
            if(hidden) {
                for (var i = 0; i < hiddenComments.length; i++) {
                    hiddenComments.item(i).style.display = "block";
                }
                showHiddenButton.textContent="Hide comments"
            } else {
                for (var i = 0; i < hiddenComments.length; i++) {
                    hiddenComments.item(i).style.display = "none";
                }
                showHiddenButton.textContent="Show hidden comments"
            }
            hidden=!hidden;
        }

            document.getElementById("addComment").onclick = function(){           
                var today = new Date();
                var time = today.getFullYear()+'-'+(today.getMonth()+1)+'-'+today.getDate();
                if(editionMode) {
                // Comment is edited
                    var commentPrivate= !(document.getElementById("privatebox").checked)
                    console.log(commentPrivate)
                    $.ajax({
                    type: "POST",
                    headers:{"Authorization":"Bearer " + getTokenFromCookie() },
                    url: "/api/comment?_id="+editedCom.getElementsByClassName("id")[0].textContent+"&courseid="+courseid+"&fileid="+fileid+"&content="+commentText.value.replace('&','%26')+"&page="+pageNumber+"&time="+time+"&visibility=" + commentPrivate,
                    success: (data) => {
                        console.log(data)
                        editedCom.firstChild.textContent = commentText.value
                        commentText.value = ""      
                        editionMode = false

                    },
                    error: (err) => {
                        console.log(JSON.stringify(err))
                    }
                })
                } else {
                // Comment is created
                    var commentPrivate= !(document.getElementById("privatebox").checked)
                    console.log(commentPrivate)
                    $.ajax({
                        type: "PUT",
                        headers: {
                            "Authorization": "Bearer " + getTokenFromCookie()
                        },
                        url: "/api/comment?courseid=" + courseid + "&fileid=" + fileid + "&content=" + commentText.value + "&page=" + pageNumber + "&time=" + time + "&visibility=" + commentPrivate,
                        success: (data) => {
                            console.log(data)
                            jsonCreatedData = JSON.parse(data)
                            var nextComment = document.createElement("p")
                            nextComment.textContent = commentText.value
                            var editLabel = document.createElement("button")
                            editLabel.textContent = "edit"
                            editLabel.className = "edit"
                            editLabel.addEventListener("click", editComment.bind(null, nextComment))
                            var deleteLabel = document.createElement("button")
                            deleteLabel.textContent = "delete"
                            deleteLabel.className = "delete"
                            deleteLabel.addEventListener("click", deleteComment.bind(null, nextComment))
                            var hideLabel = document.createElement("button")
                            hideLabel.textContent = "hide"
                            hideLabel.className = "hide"
                            hideLabel.addEventListener("click", hideComment.bind(null, nextComment))
                            var userLabel = document.createElement("label");
                            userLabel.textContent = " - Author : "+token.username;
                            userLabel.className = "user";
                            var idLabel = document.createElement("label");
                            idLabel.textContent = jsonCreatedData._id;
                            idLabel.className = "id";
                            idLabel.style.display = "none";
                            nextComment.appendChild(userLabel)
                            nextComment.appendChild(hideLabel)
                            nextComment.appendChild(editLabel)
                            nextComment.appendChild(deleteLabel)
                            nextComment.appendChild(idLabel)
                            commentHolder.insertBefore(nextComment, commentHolder.firstChild)
                            commentText.value = ""

                        },
                        error: (err) => {
                            console.log(JSON.stringify(err))
                        }
                    })
                }
            }
        })

    </script>
</body>

</html>